      PROGRAM SYNmac4
********************************************************************
*
*    Synmac4. V.4.1.   2013.10.25. 
*    1) All the elements up to No=82(Pb) will be acceptable.  Their
*        physical data will be stored into the pargram itself.
*
*
********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LMAX,LMIN,KAPP,NHYD,NP,NCAR,NE
      character*80  remmod, remlin
      character*20  fname
      parameter (maxlin=999)
      parameter (maxel=82)
      COMMON KAPP(11000), Nokelm(39)
      COMMON/NNN1/NDEP,NLINE,nlmd
      COMMON/NNN2/LMAX,LMIN
      COMMON/LIN1/AN(maxlin),WAVE(maxlin),GF(maxlin),EPLOW(maxlin),
     +            grad(maxlin),c4(maxlin),c6(maxlin)
      COMMON/LIN2/LFLAG(maxlin)
      COMMON/ELEM1/NO(maxel)
      COMMON/ELEM2/AMASS(maxel),EP1(maxel),EP2(maxel),abndn(maxel)
      COMMON/OPAC/DP5(41),RHO(41)
      COMMON/MODEL/NE(41),TEMP(41),PE(41),VTURB(41)
      COMMON/POPUL/NHYD(5,41),NP(41),NCAR(41),ASI(41),AMG(41),HTO(41),
     *             FH2(41)
      common/macvel/ vel, eps
      data maxelm/ 39 /
      data Nokelm/6,  7,  8, 11, 12, 13, 14, 16, 17, 20, 
     +           21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 
     +           38, 39, 40, 46, 56, 57, 58, 59, 60, 62, 
     +           63, 64, 65, 66, 68, 69, 70, 71, 80/
      data amass/ 5*1.0,  12.01,  14.01,  16.00,  2*1.0,  22.99,  24.31,    12
     1            26.98,  28.09,   1.00,  32.06,  35.45,  2*1.0,  40.08,     8
     2            44.96,  47.88,  50.94,  52.00,  54.94,  55.85,  58.93,     7
     3            58.69,  63.54,  65.38,  7*1.0,  87.62,  88.91,  91.22,    13
     4            5*1.0, 106.42,  9*1.0, 137.33, 138.91, 140.12, 140.91,    19
     5           144.24,   1.00, 150.36, 151.96, 157.25, 158.93, 162.50,     7
     6             1.00, 167.26, 168.93, 173.04, 174.97,  8*1.0, 200.59,    14
     7           2*1.00/                                                     2
      data ep1/ 5*1.0, 11.27, 14.53, 13.62, 2*1.0,  5.14,  7.64,  5.99,    13
     2           8.15,  1.00, 10.36, 12.97, 2*1.0,  6.11,  6.54,  6.82,     9
     3           6.74,  6.77,  7.43,  7.87,  7.86,  7.64,  7.73,  9.39,     8
     4          7*1.0,  5.70,  6.38,  6.84, 5*1.0,  8.33,  9*1.0, 5.21,    26
     5           5.61,  5.50,  5.42,  5.49,  1.00,  5.63,  5.68,  6.16,     8
     6           5.98,  5.93,  1.00,  6.10,  6.18,  6.25,  6.15, 8*1.0,    15
     7          10.44, 2*1.0/                                               3
      data ep2/ 5*1.0, 24.38, 29.60, 35.12, 2*1.0, 47.29, 15.04, 18.83, 
     2          16.35,  1.00, 23.40, 23.80, 2*1.0, 11.87, 12.80, 13.56, 
     3          14.65, 16.49, 15.64, 16.18, 17.05, 18.15, 20.29, 17.96, 
     4          7*1.0, 11.03, 12.23, 13.13, 5*1.0, 19.42, 9*1.0, 10.00, 
     5          10.85, 10.55, 10.73, 10.55,  1.00, 11.20, 11.25, 12.00, 
     6          11.52, 11.67,  1.00, 11.93, 12.05, 12.17, 13.90, 8*1.0,
     7          18.76, 2*1.0/
      data abndn/5*1.0, 8.69,  7.99,  8.91, 2*1.0,  6.33,  7.58,  6.47, 
     2           7.55,  1.00,  7.21,  5.50, 2*1.0,  6.36,  3.10,  5.02, 
     3           4.00,  5.67,  5.45,  7.67,  4.92,  6.25,  4.21,  4.60, 
     4          7*1.0,  2.97,  2.24,  2.56, 5*1.0,  1.69, 9*1.0,  2.13, 
     5           1.22,  1.55,  0.71,  1.34,  1.00,  0.80,  0.51,  1.12, 
     6           0.20,  1.10,  1.00,  0.93,  0.00,  1.08,  0.76, 8*1.0,
     7           1.27, 2*1.0/
*************************************************
      do 120 i=1,maxel
        NO(i)=i
  120 continue
c -k-
      write(*,200)
 200  format(/'@f[^̓Ăt@CĂ'/)
      read(*,210) fname
  210 format(a20)
*************************************************
      open(1,file='ELMNT.txt')
      open(3,file='MODEL.DAT')
      open(4,file=fname)
      open(6,file='log.txt')
      open(9,file='SYNOPA.DAT',form='UNFORMATTED')
c -k-      open(9,file='SYNOPA.DAT')
      open(8,file='SYNFLX.DAT')
      open(10,file='SYNROT.DAT')
*************************************************
      do 540 i=1,maxel
        read(1,550) n_atom,abndup
        abndn(i)=abndn(i)+abundup
  540 continue
  550 format(i3,f7.2)
*************************************************
      READ(3,610) remmod
  610 format(a80)
      read(3,620) NDEP
  620 format(i10)
      READ(3,630) (DP5(I),temp(i),ne(i),vturb(i), I=1,NDEP)
  630 format(f10.4,f10.1,f10.4,f10.1)
      read(3,635) vel
  635 format(f10.1)
*************************************************
      read(4,610) remlin
      read(4,640) lmin, lmax
  640 format(2f10.2)
      read(4,635) eps
      read(4,620) nline
      j=0
c -k- line selction for the following calulation -----------------------
c --------------- 2013.10.25. ------------------------------------------
      do 642 i=1,nline
        read(4,650) a1,a2,a3,a4,a5,a6,a7
  650   format(f9.2,f10.3,2f8.3,3f7.2)
*        write(*,650) a1,a2,a3,a4,a5,a6,a7
        no_el=idint(a1)
        nion=idint(100.0*(a1-dfloat(no_el)+0.001))
        if(nion.gt.1) goto 645
        do 644 k=1,maxelm
          if(no_el.eq.Nokelm(k)) goto 646
  644   continue
  645   continue
*        write(*,*) ' This is not good - '
*        write(*,650) a1,a2,a3,a4,a5,a6,a7
        goto 642
  646   j=j+1
        if(j.gt.maxlin) goto 648
        an(j)=a1
        wave(j)=a2
        eplow(j)=a3
        gf(j)=a4
        grad(j)=a5
        c4(j)=a6
        c6(j)=a7
  642 continue
c -k- line selction for the following calulation -----------------------
  648 continue
      NLINE=j
c -k- 
      write(*,390) remmod,remlin
  390 format(a80/a80)
      write(*,400) NDEP,NLINE,LMIN,LMAX
  400 FORMAT( //5X,'NO. OF DEPTH POINTS =',I5/5X,'NO. OF SPECTRAL LINES
     * =',I5/5X,'WAVELENGTH ; ',F10.2,' -',F10.2,' (A)')
      write(*,405)
  405 FORMAT(//5X,'I',3X,'OP DEP(5000)',8X,'TEMP',8X,4X,'NE',14X,
     +       'VTURB'/)
      write(*,410) (I,DP5(I),TEMP(I),NE(I),VTURB(I),I=1,NDEP)
  410 FORMAT(2X,I4,3X,1PE12.4,5X,0PF10.2,5X,1PE12.4,5X,0PF8.2)
C     PAUSE 1
*      write(*,420)
*  420 FORMAT(//,'  I',3X,'ELEM',8X,'WAVE',6X,'EPLOW',5x,'GF',6X,
*     *      'grad',5X,'c4',5x,'c6'/)
*      do 422 i=1, nline
*        write(*,430) I,AN(I),WAVE(I),EPLOW(I),GF(I),grad(I),c4(i),c6(i)
*  430   FORMAT(I4,1X,F6.2,3f10.3,3f10.2)
*  422 continue
c -k- ------------------------------------------------------------------
*      write(*,330)
*  330 FORMAT(/10X,'CALL STATE ---  UNDER CALCULATION')
      do 95 i=1,maxel
        abndn(i)=10.**(abndn(i)-12.0)
   95 continue
      do 97 i=1,nline
        gf(i)=10**gf(i)
C ------- 1988/08/19  change the treatment of the damping constants --------
C     IFLAG=1  input  GRAD,C4,C6     0.0  ķ --> gam=10*classical
C          =2  input  GRAD  0.0 ޤ c4  C6   0.0 Ų  ޱ
C               --> GRAD=CLASSICAL, C4 & C6    ޼  خ  ١
C          =3  GRAD<>0.0   ޱ  --->      خ  ١
C ------------------- following WID80 --------------------------------------
         IFLAG=3
         IF(GRAD(I).EQ.0.0) THEN
            IF(C4(I).EQ.0.0 .AND. C6(I).EQ.0.0) THEN
              IFLAG=1
            ELSE
              IFLAG=2
            ENDIF
         ENDIF
         LFLAG(I)=IFLAG
         GRAD(I)=10.**GRAD(I)
         IF(IFLAG.EQ.1 .OR. IFLAG.EQ.2) GRAD(I)=0.2236E16/(WAVE(I)**2)
         C4(I)=10.**C4(I)
         C6(I)=10.**C6(I)
   97 continue
C ---------------------------------------------------------------------------
      DO 100 I=1,NDEP
         dp5(i)=10.0**dp5(i)
         NE(I)=10.0**NE(I)
         PE(I)=NE(I)*1.38066E-16*TEMP(I)
         CALL STATE(I,HTO(I))
  100 CONTINUE
*      write(*,340)
*  340 FORMAT(//10X,'CALL STATE --  FINISH, AND START <CALL KAPPA>'//)
      CALL KAPPA
      call synth2
      call macro
      close(9,status='delete')
      STOP
      END



      SUBROUTINE STATE(ID,HTOT)
      IMPLICIT REAL*8 (A-H,O-Z)
      parameter (maxel=82)
      save
      REAL*8 NHYD,NP,NCAR,NE
      DIMENSION ALFA(14),QA(14),CHI0(14),AS(14),PRLOG(14)
      COMMON/POPUL/NHYD(5,41),NP(41),NCAR(41),ASI(41),AMG(41),
     *  HTO(41),FH2(41)
      COMMON/OPAC/DP5(41),RHO(41)
      COMMON/MODEL/NE(41),TEMP(41),PE(41),VTURB(41)
      COMMON/ELEM1/NO(maxel)
      COMMON/ELEM2/AMASS(maxel),EP1(maxel),EP2(maxel),abndn(maxel)
c -k- final abndn(*) is already converted to 10**(abndn-12.0) ----------
c-k- old version - H, He, C, O, Na, Mg, Al, Si, S, Fe - 10 atoms
*      DATA ALFA/ 1.0, 6.3E-2, 4.2E-4, 6.9E-4, 1.9E-6, 4.0E-5,3.3E-6,
*     *  4.5E-5, 1.6E-5, 3.2E-5/
*      DATA CHI0/ 13.595, 24.581, 11.256,13.614,5.138,7.644,5.984,8.149,
*     *  10.357, 7.830 /
*      DATA AS/1.008,4.003,12.000,15.999,22.991,24.312,26.982,28.086,
*     *  32.064, 55.847 /
c -k- 2013.10.25. all in Mihalas(1966).H,He,CNO,Na,Mg,Al,Si,S,K,Ca,Cr,Fe
      DATA NELEM,NLH/ 14, 5/
      DATA PRLOG/ 0.00, 0.60, 0.10, 0.62,-0.05, 0.00, 0.60,-0.48,
     +            0.12,-0.05, 0.00, 0.60,-0.07, 0.38/
      DATA XK/1.38054E-16/
      data yn/0/
c -k- ------------------------------------------------------------------
      if(yn.gt.0) goto 100
      yn=+10
c -k- abudances relative to that of H, real number
      alfa(1)=1.0
      alfa(2)=0.15
      alfa(3)=abndn(6)
      alfa(4)=abndn(7)
      alfa(5)=abndn(8)
      alfa(6)=abndn(11)
      alfa(7)=abndn(12)
      alfa(8)=abndn(13)
      alfa(9)=abndn(14)
      alfa(10)=abndn(16)
      alfa(11)=5.0E-8
      alfa(12)=abndn(20)
      alfa(13)=abndn(24)
      alfa(14)=abndn(26)
c -k- ionization potential (eV)
      chi0(1)=13.595
      chi0(2)=24.581
      chi0(3)=ep1(6)
      chi0(4)=ep1(7)
      chi0(5)=ep1(8)
      chi0(6)=ep1(11)
      chi0(7)=ep1(12)
      chi0(8)=ep1(13)
      chi0(9)=ep1(14)
      chi0(10)=ep1(16)
      chi0(11)=4.339
      chi0(12)=ep1(20)
      chi0(13)=ep1(24)
      chi0(14)=ep1(26)
c -k- atomic mass in mass number
      as(1)=1.008
      as(2)=4.003
      as(3)=amass(6)
      as(4)=amass(7)
      as(5)=amass(8)
      as(6)=amass(11)
      as(7)=amass(12)
      as(8)=amass(13)
      as(9)=amass(14)
      as(10)=amass(16)
      as(11)=39.098
      as(12)=amass(20)
      as(13)=amass(24)
      as(14)=amass(26)
c -k-
*      write(*,*) ' in STATE. alfa, chi0, amass, pr_log'
*      do 950 i=1, nelem
*        write(*,940) i,alfa(i),chi0(i),as(i),prlog(i)
*  940   format(i3,e12.3, 3f8.3)
  950 continue
c -k-
  100 continue
      ELPRES=PE(ID)
      T=TEMP(ID)
      THETA=5040./T
      Z=2.5*DLOG10(T)
      Q=0.0
      SUM=0.0
      XMU=AS(1)
      DO 1 J=2,NELEM
          XMU=XMU+AS(J)*ALFA(J)
          SUM=SUM+ALFA(J)
          QA(J)=-CHI0(J)*THETA+Z+PRLOG(J)-0.4772
          QA(J)=10.0**QA(J)/ELPRES
          Q=Q+ALFA(J)*QA(J)/(1.0+QA(J))
    1 CONTINUE
      XMU=XMU/AS(1)
      QHM=-.747*THETA+Z+.1249
      QH2=12.533505+(-4.9251644+5.6191273E-2*THETA-3.268766E-3*
     *    THETA**2)*THETA
      QH2P=11.206998+(-2.7942767-7.9196803E-2*THETA+2.4790744E-2*
     *    THETA**2)*THETA
      QHM=10.0**QHM
      QH2=10.0**QH2
      QH2P=10.0**QH2P
      ETOT=ELPRES/(XK*T)
      TERM=4.1416E-16*ETOT/(T*DSQRT(T))
      SB=1.0*TERM*DEXP(157896./T)
      NHYD(1,ID)=SB
      UHYD=SB
      DO 2 I=2,16
          AI2=DBLE(I*I)
          SB=AI2*TERM*DEXP(157896./(AI2*T))
          UHYD=UHYD+SB
          IF(I.GT.NLH) GO TO 2
          NHYD(I,ID)=SB
    2 CONTINUE
      G2=1.0/UHYD
      G3=ELPRES/QHM
      G4=ELPRES/QH2P
      G5=ELPRES/QH2
      AA=1.0+G2+G3
      D=G2-G3
      E=G2*(G4/G5)
      BB=2.0*(1.0+E)
      C1=G5*BB**2+AA*D*BB-E*AA**2
      C2=2.0*AA*E-D*BB+AA*BB*Q
      C3=-(E+BB*Q)
      F1=(-C2+DSQRT(C2*C2-4.0*C1*C3))/(2.0*C1)
      F5=(1.0-AA*F1)/BB
      F4=E*F5
      F3=G3*F1
      F2=G2*F1
      FZE=F2-F3+F4+Q
      Y=1.0+(F1+F2+F3+F4+F5+SUM)/FZE
      FH=F1
      R1=F1/FZE
      Y=1.0+G2+G3+2.0*G5*R1+2.0*G2*G4*R1
      HNUM=ELPRES*R1/(XK*T)
      HPNUM=HNUM*G2
      NP(ID)=HPNUM
      YHNUM=Y*HNUM
      HTOT=YHNUM
      ETOT=YHNUM*FZE
      DO 6 IL=1,NLH
         NHYD(IL,ID)=HPNUM*NHYD(IL,ID)
    6 CONTINUE
      NCAR(ID)=ALFA(3)*YHNUM
      XPNUM=NCAR(ID)*QA(3)/(1.0+QA(3))
      NCAR(ID)=NCAR(ID)-XPNUM
      AMG(ID)=ALFA(6)*YHNUM
      XPNUM=AMG(ID)*QA(6)/(1.0+QA(6))
      AMG(ID)=(AMG(ID)-XPNUM)/HNUM
      ASI(ID)=ALFA(8)*YHNUM
      XPNUM=ASI(ID)*QA(8)/(1.0+QA(8))
      ASI(ID)=(ASI(ID)-XPNUM)/HNUM
      NE(ID)=ETOT
      YY=1.67333E-24*XMU
      Y=XK*T/ELPRES
      RHO(ID)=YY/(Y*FZE)
      FH2(ID)=F5/YY
c -k-
*      if(id.eq.10) then 
*        write(*,*) ' State - Ne, HTOT', Ne(id), HTOT
*      endif
c -k-
      RETURN
      END



      SUBROUTINE KAPPA
C----- THIS ROUTINE MAKES DISK(9) WHICH INCLUDES ABSORPTION COEFFICEINTS
C      CONT.OPACITY IS INDEPENDENT ON WAVELENGTH. A CALCULATION OF THE
C      LINES IS CUT OFF AT THE M * DOPP(STD).
C      1983/9/30
      IMPLICIT REAL*8 (A-H,O-Z)
      save
      parameter (maxlin=999)
      parameter (maxel=82)
      REAL*8 LMAX,LMIN,KAPP
      COMMON KAPP(11000)
      COMMON/NNN1/NDEP,NLINE,NLMDA
      COMMON/NNN2/LMAX,LMIN
      COMMON/LIN1/AN(maxlin),WAVE(maxlin),GF(maxlin),EPLOW(maxlin),
     +            grad(maxlin),c4(maxlin),c6(maxlin)
      COMMON/LIN2/LFLAG(maxlin)
      COMMON/ELEM1/NO(maxel)
      COMMON/ELEM2/AMASS(maxel),EP1(maxel),EP2(maxel),abndn(maxel)
      data dlx/0.50d1/
c -k- -----------------------------------------------------------
      REWIND 9
      NLMDA=IDINT((LMAX-LMIN)*100.)+1
*      write(*,360) NLMDA
*  360 FORMAT(/' ** KAPPA **'/' NO. OF WAVE POINTS =',I5)
      IF(NLMDA .LE. 11000) GO TO 500
      write(*,300) NLMDA
  300 FORMAT(/' **SUB KAPPA**   WAVE POINTS =',I5,' TOO LARGE')
      RETURN
  500 DO 1000 IDEPTH=1,NDEP
      WMED=(LMAX+LMIN)/2.0
      OPCON=OPCNT(IDEPTH,    WMED, 1)
      OP500=OPCNT(IDEPTH, 5000.D0, 1)
      WMED=OPCON/OP500
*      write(*,370) IDEPTH,WMED
*  370 FORMAT(' IDEP =',I3,2X,'CONT/5000 RATIO=',F6.2)
      DO 800 ILAMD=1,NLMDA
        KAPP(ilamd)=WMED
        wvl=lmin+DBLE(ilamd-1)*0.01
        do 900 ielm=1,nline
           nan=IDINT(an(ielm))
           dlamd=DABS(wvl-wave(ielm))
           if(nan.gt.31 .or. gf(ielm).lt.0.1) go to 910
           KAPP(ilamd)=KAPP(ilamd)+OPLINE(IDEPTH,IELM,DLAMD,
     *                         DOPPLR)/OP500
           go to 900
  910      if(dlamd.lt.dlx) KAPP(ilamd)=KAPP(ilamd) +
     *                      OPLINE(IDEPTH,IELM,DLAMD,DOPPLR)/OP500
  900   continue
  800 continue
c -k- to debugg, 2013.10.23.
*        if(idepth.eq.10) then
*           write(*,*) ' in KAPP. OPCON, OP500'
*           write(*,*) opcon, op500
*           write(*,*)
*           write(*,*) ' in KAPP.  KAPP(10)'
*           write(*,925) (lmin+0.01*float(j),KAPP(j),j=1,nlmda,5)
*  925      format(F10.3,2x,F10.4)
*        endif
c -k-
        WRITE(9) IDEPTH,NLMDA
*        WRITE(9,901) IDEPTH,NLMDA
*  901   format(2i5)
        write(9) (KAPP(J),J=1,NLMDA)
*        write(9,902) (KAPP(J),J=1,NLMDA)
*  902   format(10e13.5)
 1000 CONTINUE
      ENDFILE 9
      RETURN
      END



      subroutine SYNTH2
********************************************
*  append    1985/04/08
********************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LMAX,LMIN,KAPP,NE
      DIMENSION TAB(41,100),FT(41),DPNEW(41)
      common  kapp(11000)
      COMMON/NNN1/NDEP,NLINE,nlm
      COMMON/NNN2/LMAX,LMIN
      COMMON/OPAC/DP5(41),rho(41)
      COMMON/MODEL/NE(41),TEMP(41),pe(41),vturb(41)
      common/flxx/flxxx(11000)
********************************************
      nlm=1000
      IJ=-99
 9999 REWIND 9
      IJ=IJ+100
      IK=IJ+99
      write(*,330) IJ
  330 FORMAT(/5X,'<< NEW WAVE LENGTH AREA, START >>  IJ =',I4)
      IF(IK .GT. NLM) IK=NLM
c -k- ---------------------------------------------------
      DO 9000 I=1,NDEP
        READ(9) ID,NLM
*        READ(9,710) ID,NLM
        read(9) (KAPP(J),J=1,NLM)
*        read(9,720) (KAPP(J),J=1,NLM)
*  710   format(2i5)
*  720   format(10e13.5)
c -k- ---------------------------------------------------
*        if(i.eq.10) then
*          write(*,*) ' Syth2.  Read in KAPP'
*          write(*,610) (KAPP(j),j=1,nlm,5)
*        endif
c -k- ---------------------------------------------------
        IF(I. NE. ID) GO TO 5000
        JJ=0
        DO 900 J=IJ,IK
          JJ=JJ+1
          TAB(I,JJ)=KAPP(J)
  900   continue

c -k- for degugging --------------------------------------
*        if(i.eq.10) then
*          write(*,*) ' SYNTH2. ID, NLM =',ID, NLM
*          write(*,*) ' SYNTH2. TAB(10,*)'
*          write(*,610) (tab(i,kk), kk=1,100,5)
*  610     format(5(1pE10.2))
*        endif
c -k- for degugging --------------------------------------

 9000 CONTINUE
C
      J100=100
      IF(IK .EQ. NLM) J100=NLM-(NLM/100)*100
      DO 800 J=1,J100
        IJJ=IJ+J-1
        DO 8000 I=1,NDEP
          FT(I)=TAB(I,J)
 8000   continue

c -k- ----------------------------------------------------
*        if(j.eq.20) then
*        write(*,*) '  Synth2.  DP5 & temp'
*        do 8020 i=1,ndep
*          If possible, do not use Do-arrangement, but use the usual Do-loop.
*          write(*,620) i,dp5(i),temp(i), NE(i)
*  620     format(i5,3(1pe13.3))
* 8020   continue
*      write(*,405)
*  405 FORMAT(/5X,'I',3X,'OP DEP (5000)',8X,'TEMP',8X,4X,'NE',14X,'VTURB'
*     *       /)
*      write(*,410) (I,DP5(I),TEMP(I),NE(I),VTURB(I),I=1,NDEP)
*  410 FORMAT(I4,3X,1PE12.4,5X,0PF10.2,5X,1PE12.4,5X,0PF8.2)
*        endif
c -k- ----------------------------------------------------

        CALL INTEG(DP5,FT,DPNEW,NDEP)

c -k- ----------------------------------------------------
*        if(j.eq.80) then
*          write(*,*) ' Synth2. new optical depth'
*          do 8012 ik=1,ndep,2
*            write(*,860) ik,dp5(ik),dpnew(ik)
*  860       format(i3,2(1pe13.4))
* 8012   continue
*        endif
*   ----------------------------------

        do 8018 i=1,ndep
          dpnew(i)=DLOG10(dpnew(i))
 8018   continue

*   ----------------------------------

        CALL FLUX(DPNEW,NDEP,IJJ)

       IF(IK.EQ.NLM .AND. J.EQ.J100) GO TO 1000
  800 CONTINUE
      G O T O   9999
C
 1000 write(*,300)
  300 FORMAT(//20X,'******************************'//
     *    21X,'SPECTRUM SYNTHESIS  finished '//20X,
     *             '******************************'/)
      rewind 8
      write(8,810) lmax,lmin,nlm
  810 format(2f20.5,i10)
      do 822 i=1,nlm
        write(8,820) lmin+0.01*(i-1),flxxx(i)
  820   format(F10.3,1pe12.3)
  822 continue
      endfile 8
      return
 5000 write(*,310)
  310 FORMAT(//10X,'?? DISK(9) DEPTH INDEX TROUBLE !!!'//)
      return
      END



      subroutine  macro
*  ----------  1985/10/10  -----------
      IMPLICIT REAL*8 (A-H,O-Z)
      real*8  lmax,lmin
      dimension fip(11000)
      common/macvel/vel,eps
      COMMON/NNN1/NDEP,NLINE,nlm
      COMMON/NNN2/LMAX,LMIN
      common/flxx/flux(11000)
      fwhm=lmax*vel/2.99793e5 * 1000.
* ----  dl/l=v/c      v    macro-turbulence   Ž
      call conflx(flxcnt)
      call instr(nlm,lmin,fwhm,fip)
**    fmax=fip(1)
**    fmin=fip(1)
**    do 2000 i=2,nlm
**      if(fmax.lt.fip(i)) fmax=fip(i)
**      if(fmin.gt.fip(i)) fmin=fip(i)
*2000 continue
*-----  call  conflx  and other modification  1985/12/15  ------------
      do 2100 i=1,nlm
**     fip(i)=fip(i)/fmax*100.0
       fip(i)=fip(i)/flxcnt*100.0
 2100 continue
      write(10,810) lmax,lmin,nlm
  810 format(2f20.5,i10)
      do 812 i=1,nlm
        write(10,920) lmin+0.01*float(i-1),fip(i)
  920 format(2f10.3)
  812 continue
      do 100 i=1,nlm
        flux(i)=fip(i)
  100 continue
      return
      end



      subroutine  conflx(flxcnt)
*---  1985/12/15
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 NE,lmin,lmax
      DIMENSION DPNEW(41),xkappa(41)
      COMMON/NNN1/NDEP,NLINE,nlmd
      COMMON/NNN2/LMAX,LMIN
      COMMON/OPAC/DP5(41),RHO(41)
      xlmd=(lmax+lmin)/2.0
      do 1000 idep=1,ndep
         xkappa(idep)=opcnt(idep, xlmd, 1)/opcnt(idep, 5000.d0, 1)
 1000 continue
      call integ(dp5, xkappa, dpnew, ndep)
      do 1010 i=1,ndep
 1010   dpnew(i)=DLOG10(dpnew(i))
      call flux2(dpnew, ndep, 1, flxcnt)
      return
      end


      DOUBLE PRECISION FUNCTION OPCNT(ID,WAVE,IFLAG)
C---- IFLAG = 0 .... NO SCATTERING
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8  NHYD,NP,NCAR,NE
      COMMON/MODEL/NE(41),TEMP(41),PE(41),VTURB(41)
      COMMON/POPUL/NHYD(5,41),NP(41),NCAR(41),ASI(41),AMG(41),HTO(41),
     *   FH2(41)
      COMMON/OPAC/DP5(41),RHO(41)
      T=TEMP(ID)
      TH=5040./T
      HKT=4.793E-11/T
      FR=2.997925E18/WAVE
      HNUM=0.0
      DO 14 IL=1,5
       HNUM=HNUM+NHYD(IL,ID)
   14 CONTINUE
      OPCNT=1.0E-26*(ABNEGH(T,FR)*HNUM*PE(ID) + AVCAR(TH,FR)*NCAR(ID)
     2     + AVMET(TH,FR,ASI(ID),AMG(ID))*HNUM)
      OPCNT=(OPCNT + ABHYD(T,FR)*HNUM+H2PLOP(T,FR)*NHYD(1,ID)*NP(ID))
     *     /RHO(ID)
      IF(IFLAG .EQ. 0) RETURN
C-----  1   RAYLEIGH BY NEUTRAL HYDROGEN ---------
      W2=DMAX1(WAVE,1215.7D0)
      W2=W2*W2
      W8=W2**4
      RAYH1=(2.784+(1.422E-6+5.799E-13*W2)*W2)/W8
C----- 2   RAYLEIGH FROM H2
      RAYH2=(1.61 +(1.28 E-6+8.14 E-13*W2)*W2)/W8
C----- 3   THOMSON
      THMSN=6.655E-25*NE(ID)/RHO(ID)
      OPCNT=OPCNT+RAYH1*HNUM/RHO(ID)+RAYH2*FH2(ID)+THMSN
      RETURN
      END



      DOUBLE PRECISION FUNCTION OPLINE(IDEP,NOLN,DLAMD,DOPPLR)
C---- REVISED LINE OPACITY ROUTINE BASED ON MY OLD VERSION CONTAINED
C     COEFFICIENTS FOR CALULATION OF THE PARTITION FUNCTION.
C     1983/09/29
C     NLINE = LINE NO. IN /ATOM/ WHICH WE ESTIMATE
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 NHYD,NP,NCAR,NE
      DOUBLE PRECISION VOIGT
      DIMENSION U(3)
      save
      parameter (maxlin=999)
      parameter (maxel=82)
      COMMON/LIN1/AN(maxlin),WAVE(maxlin),GF(maxlin),EPLOW(maxlin),
     +            grad(maxlin),c4(maxlin),c6(maxlin)
      COMMON/LIN2/iFLAG(maxlin)
      COMMON/ELEM1/NO(maxel)
      COMMON/ELEM2/AMASS(maxel),EP1(maxel),EP2(maxel),abndn(maxel)
      COMMON/MODEL/NE(41),TEMP(41),PE(41),VTURB(41)
      COMMON/POPUL/NHYD(5,41),NP(41),NCAR(3,41),HTO(41),FH2(41)
      COMMON/OPAC/DP5(41),RHO(41)
      data nelm / 39 /
      DATA HCK/ 1.4387863E8 /
      DATA IDOLD,NOOLD,DLOLD/ -1,-1,100./
c -k- -----------------------------------------
*      if(idep.eq.10) then
*        write(*,*) ' in opline. DP5, Temp, Vturb ... '
*        write(*,*) idep, dp5(idep), temp(idep), vturb(idep), rho(idep) 
*      endif
c -k- -----------------------------------------
      IF(IDEP.EQ.IDOLD .AND. NOLN.EQ.NOOLD .AND. DLAMD.NE.DLOLD)
     *   GO TO 1000
      ID=IDEP
      WV=WAVE(NOLN)
      TM=TEMP(ID)
      iatom=IDINT(AN(NOLN))
*      DO 100 I=1,nelm
*        IF(IELM .EQ. NO(I)) GO TO 200
*  100 CONTINUE
  200 ION=IDINT((AN(NOLN)-DBLE(iatom))*100.0+.01)
c -k- 2013.10.23. ----------------------------------------------------
*      WRITE(*,600) ID,WV,TM,IELM,ION
*  600 FORMAT(2X,'ID=',I2,'  WV=',F8.2,'   TM=',F8.2,'   IELM=',I2,
*     *  '  ION=',I2)
************************  1985  07  09  ***********************
      DO 90 J=1,3
   90 U(J)=PART(temp(ID),iatom,j)
*        WRITE(*,610) (U(J),J=1,3)
*  610 FORMAT(2X,'PART. FT. U =',3(F8.2))
C     PAUSE KAPPA1
      U12=DLOG10(2.0*U(2)/U(1))
      U23=DLOG10(2.0*U(3)/U(2))
      UID=U(ION+1)
      VEL=DSQRT(0.01651225*TM/AMASS(Iatom)+VTURB(ID)**2)
c -k-
*      if(idep.eq.10) then
*        WRITE(*,620) TM, AMASS(i),VTURB(id),VEL
*  620   FORMAT(/' TM=',F8.2,' AMASS=',F8.2,' VTURB=',f8.2,' VEL=',F8.2)
*      endif
C---- SAHA'S EQ.  PH1 & PH2 ----------------
      P9=-0.4772+2.5*DLOG10(TM)
      PH1=U12+P9-5040.*EP1(iatom)/TM
      PH2=U23+P9-5040.*EP2(iatom)/TM
      PH1=10**PH1/PE(ID)
      PH2=10**PH2/PE(ID)
      P9=1.0/(1.0+PH1*(1.0+PH2))
      IF(ION .EQ. 1) P9=PH1*P9
      IF(ION .EQ. 2) P9=ph1*PH2*P9
      XNO=ABNDN(iatom)*P9*     HTO(ID)*DEXP(-EPLOW(NOLN)*11604.5/TM)
     *     /(UID*RHO(ID))
C ----------- Treatment of dampings were changed  1988/08/19. ----------
c -k- 2013.10.24.-- g6₯ɑ傫BHTORBς閘A
c@_sOPĂ
c  ł̌` unsold ̂̂ŁAc4, c6̒` K&B Ƃ͈قȂ邩A
c  p͕̂sK؂
c -k-
*      IF(iFLAG(NOLN).EQ.1) THEN
*         GAMMA=10.*GRAD(NOLN)
*         GO TO 2550
*      ENDIF
*      G4=3.3107e3*c4(NOLN)**0.6667*NE(ID)*TM**0.1667
*      G6=5.385e3*c6(NOLN)**0.4*TM**0.3*(HTO(ID)-NP(ID))
*      GAMMA=GRAD(NOLN)+G4+G6
C ----------------------------------------------------------------------
c -- <6> width6
      IF(iFLAG(NOLN).EQ.1) THEN
         GAMMA=10.*GRAD(NOLN)
         GO TO 2550
      ENDIF
      c44=c4(noln)
      c66=c6(noln)
      zeff=dble(ion+1)**2
      epup=eplow(noln)+1.23985d-4/(wv*1.0d-8)
      zksi=13.595d0*zeff/epup
      if(c4(noln).eq.1.0) c44=zksi**2.5*1.0d-8
      if(c6(noln).eq.1.0) c66=zksi**0.8*6.5d-9
      h1=HTO(ID)-NP(ID)
      g4=c44 *ne(id)
**    g6=c6(noln) *(2.d0+0.42d0*he1(id))*h1*(tm*1.0d-4)**0.3
      g6=c66      *(2.d0               )*h1*(tm*1.0d-4)**0.3
      gamma=grad(noln)+g4+g6
*      if(id.eq.20) write(*,661) g4,g6,ne(id),h1
*  661 format(/'   g4=',1pe10.3,' g6=',e10.3,' Ne=',e10.3,' H1=',e10.3)
c -- <7> classical  <8> 5 * classical
 2550 continue
*      if(idep.eq.10) then
*        write(*,652)  NOLN, WV, VEL
*  652   format(' NOLN, WV, VEL  =',i3,2(1pe10.2))
*      endif
c -k- 
      DNUD=VEL*1.0E13/WV
      DOPPLR=WV*VEL/2.997925E5
      AA=GAMMA/(12.5664*DNUD)
      XK=1.479733E-2*GF(NOLN)*XNO/DNUD*(1.0-DEXP(-HCK/(WV*TM)))
 1000 V=DLAMD/DOPPLR
      OPLINE=XK*VOIGT(AA,V)
c -k- 2013.10.23. ---------------------------------------------
*      if(idep.eq.10) then
*        write(*,630) ph1, ph2,p9,hto(id),abndn(i),eplow(noln),rho(id),
*     1               xno
*  630   format(2x,'ph1, ph2,p9,hto(id),abndn(i),eplow(noln),rho(id),xno=
*     1'/8(1pe10.2))
*        write(*,640) iflag(noln), GAMMA,Grad(noln), C4(noln), C6(noln)
*  640   format(' iflag, GAMMA, Grad(noln), c4, c6 =',i3,4(1pe10.2))
*        write(*,650) DNUD, DOPPLR, AA, XK, V, opline
*  650   format(' DNUD, DOPPLR, AA, &  =',6(1pe10.2))
*      endif
C ----------------------------------------------------------------------
      IDOLD=ID
      NOOLD=NOLN
      DLOLD=DLAMD
      RETURN
      END



      subroutine  flux(dpnew,ndim,nowv)
*---- 1985/12/15
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension dpnew(ndim)
      common/flxx/flxxx(11000)
      call flux2(dpnew,ndim,nowv,flx)
      flxxx(nowv)=flx
      return
      end



      SUBROUTINE FLUX2(DPNEW,ndim,nowv,fl)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 NE,lmax,lmin
      DIMENSION DPNEW(ndim),TAU(18),COEF(18),BNU(41)
      COMMON/NNN1/NDEP,NLINE,nlmd
      COMMON/NNN2/LMAX,LMIN
      common/model/ne(41),temp(41),pe(41),vturb(41)
**      common/flxx/flxxx(11000)
      save
      data ntau/ 18 /
      data tau/    -1.6986517, -1.1085987, -0.8859529, -0.6642571,
     * -0.5242399, -0.3533310, -0.2393295, -0.0933218,  0.0046034,
     *  0.1319414,  0.2195632,  0.3366870,  0.4193746,  0.5331228,
     *  0.6271834,  0.7922465,  0.9314575,  1.0481578  /
      data coef/4.4085001e-2, 3.9623539e-2, 4.8435531e-2, 4.3171799e-2,
     *          5.5634087e-2, 4.7445674e-2, 5.3222701e-2, 4.2678682e-2,
     *          3.9544534e-2, 2.9418954e-2, 2.2992746e-2, 1.5341360e-2,
     *          9.5637224e-3, 5.3585606e-3, 2.7514763e-3, 7.0044439e-4,
     *          2.6685720e-5, 4.4949231e-6 /
      data iq/ 1 /
c -k- ----------------------------------------
      wv=lmin+DBLE(nowv-1)*0.01
      if (iq.ne.1) go to 1000
      WVV=(lmax+lmin)/2.0
      FR=2.997925E18/WVV
      FR10=FR*1.0E-10
      DO 200 I=1,ndep
         X=4.79943E-11*FR/TEMP(I)
         EX=DEXP(X)-1.0
         BNU(I)=1.47452E-17*FR10**3/EX
  200 CONTINUE
      iq=-1
 1000 CONTINUE
c -k- ----------------------------------------
*      Unless you do not use the save stetment, BNU will be indefinite error.
*      write(*,*) ' DPNEW, BNU, TAU(i)'
*      do 306 k=1,ndep,2
*        write(*,307) k,dpnew(k),bnu(k),tau(1)
*  307   format(i3,f8.3,e13.4,f8.3)
*  306 continue
c -k- ----------------------------------------
      FL=0.0
      DO 300 I=1,ntau
         IF(TAU(i).LT.DPNEW(1)) THEN
            FLX=BNU(1)
            GO TO 350
         ENDIF
         IF(TAU(i).GT.DPNEW(NDEP)) THEN
            FLX=BNU(NDEP)
            go to 350
         ENDIF
         CALL HOKAN(NDEP,DPNEW,BNU,2,TAU(I),FLX)
c -k- --------------------------------------------------
*         if(flx.lt.0.0) then
*           write(*,*) ' Flux < 0 : i=',i
*           write(*,*) ' DPNEW, BNU, TAU(i), FLX'
*           do 306 k=1,ndep,2
*             write(*,307) k,dpnew(k),bnu(k),tau(i),flx
*  307        format(i3,2(f8.3,e13.4))
*  306      continue
*         endif
c -k- --------------------------------------------------
  350    FL=FL+COEF(I)*FLX
  300 CONTINUE
*      write(*,600) NOWV,WV,FL
*  600 FORMAT(' <FLUX> ',I4,' WAVE =',F8.2,' FLUX =',1PE12.5)
c -k-      flxxx(nowv)=fl
      RETURN
      END




      subroutine instr(n,wave0,fwhm,fip)
**---------------------------------------------------
**    FWHM  --  in  mA.     WAVE0 -- LMIN  in  A.
**
**    1985.07.20.        Gaussian  Distribution
**
**    SIGM = Standard Deviation
**---------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension fip(n)
      common/flxx/flx(11000)
      data dwv / 0.01 /
      sigm=0.588705*fwhm/1000.0
      if(fwhm .eq. 0.0) then
         do 10 i=1,n
           fip(i)=flx(i)
   10    continue
         return
      endif
      if(fwhm .lt. 50.) then
          nint=31
        else
          nint=IDINT((fwhm+5.)/10.)*6 + 1
      endif
      do 10000 i=1,n
        sum=0.0
        do 1000 j=1,nint
          jj=j-(nint/2+1)
          y=DBLE(jj)*dwv
          gaus=y/sigm
          gaus=Dexp(-gaus*gaus/2.0)
          ijj=i+jj
          if(ijj .gt. n) then
             fx=flx(n)
            go to 100
          endif
          if(ijj .lt. 1) then
            fx=flx(1)
            go to 100
          endif
          fx=flx(ijj)
  100     sum=sum + fx*gaus/sigm*0.39894228
 1000   continue
      fip(i)=sum*dwv
10000 continue
      return
      end





      DOUBLE PRECISION FUNCTION PART(TEMP,iatom,ION)
C---- Partition  function
C---- 1984/11/9  Irwin(1981) Ap.J. Suppl. 45, p.621
      IMPLICIT REAL*8 (A-H,O-Z)
      parameter (maxel=82)
      DIMENSION PPFC(6,3,maxel),A(6),U(3)
      DIMENSION C6(6,3),C7(6,3),C8(6,3),C11(6,3),C12(6,3),C13(6,3),
     & C14(6,3),C16(6,3),C17(6,3),C20(6,3),C21(6,3),C22(6,3),
     & C23(6,3),C24(6,3),C25(6,3),C26(6,3),C27(6,3),C28(6,3),
     & C29(6,3),C30(6,3),C39(6,3),C40(6,3),C46(6,3),C56(6,3),
     & C57(6,3),C58(6,3),C59(6,3),C60(6,3),C62(6,3),C63(6,3),
     & C64(6,3),C66(6,3),C69(6,3),C70(6,3),C80(6,3)
      dimension c38(6,3),c65(6,3),c68(6,3),c71(6,3)
      COMMON/ELEM1/NO(maxel)
      COMMON/ELEM2/AMASS(maxel),EP1(maxel),EP2(maxel),abndn(maxel)
      EQUIVALENCE
     2 (PPFC(1,1, 6),C6 (1,1)),(PPFC(1,1, 7),C7 (1,1)),
     3 (PPFC(1,1, 8),C8 (1,1)),(PPFC(1,1,11),C11(1,1)),
     4 (PPFC(1,1,12),C12(1,1)),(PPFC(1,1,13),C13(1,1)),
     5 (PPFC(1,1,14),C14(1,1)),(PPFC(1,1,16),C16(1,1)),
     6 (PPFC(1,1,17),C17(1,1)),(PPFC(1,1,20),C20(1,1)),
     7 (PPFC(1,1,21),C21(1,1)),(PPFC(1,1,22),C22(1,1)),
     8 (PPFC(1,1,23),C23(1,1)),(PPFC(1,1,24),C24(1,1)),
     9 (PPFC(1,1,25),C25(1,1)),(PPFC(1,1,26),C26(1,1)),
     * (PPFC(1,1,27),C27(1,1)),(PPFC(1,1,28),C28(1,1))
      equivalence
     2 (PPFC(1,1,29),C29(1,1)),(PPFC(1,1,30),C30(1,1)),
     2 (PPFC(1,1,38),C38(1,1)),
     3 (PPFC(1,1,39),C39(1,1)),(PPFC(1,1,40),C40(1,1)),
     4 (PPFC(1,1,46),C46(1,1)),(PPFC(1,1,56),C56(1,1)),
     5 (PPFC(1,1,57),C57(1,1)),(PPFC(1,1,58),C58(1,1)),
     6 (PPFC(1,1,59),C59(1,1)),(PPFC(1,1,60),C60(1,1)),
     7 (PPFC(1,1,62),C62(1,1)),(PPFC(1,1,63),C63(1,1)),
     8 (PPFC(1,1,64),C64(1,1)),(PPFC(1,1,65),C65(1,1)),
     9 (PPFC(1,1,66),C66(1,1)),(PPFC(1,1,68),C68(1,1)),
     * (PPFC(1,1,69),C69(1,1)),(PPFC(1,1,70),C70(1,1)),
     1 (PPFC(1,1,71),C71(1,1)),(PPFC(1,1,80),C80(1,1))
      save
C --------
      DATA C6  /
     2  9.21720021E+0,-6.57474804E+0, 2.04630537E+0,-2.86334470E-1,
     3  1.83809654E-2,-4.29672351E-4,               -1.85578951E+2,
     4  1.16815901E+2,-2.91473937E+1, 3.63531100E+0,-2.26513357E-1,
     5  5.63890268E-3,               -3.91254213E+2, 2.45609224E+2,
     6 -6.15277245E+1, 7.68864516E+0,-4.79276444E-1, 1.19227494E-2/
      DATA C7 /
     2  2.88717295E+2,-1.68872285E+2, 3.91254756E+1,-4.45059341E+0,
     3  2.47223728E-1,-5.31945494E-3,                1.28777940E+2,
     4 -7.95497944E+1, 1.96686627E+1,-2.39615935E+0, 1.43891814E-1,
     5 -3.40476068E-3,               -8.61956970E+1, 5.22049927E+1,
     6 -1.25274613E+1, 1.51416152E+0,-9.19393680E-2, 2.23943277E-3/
      DATA C8 /
     2 -6.26219795E+0, 5.12651680E+0,-1.44691306E+0, 2.23196759E-1,
     3 -1.78196943E-2, 5.71458469E-4,               -1.11049302E+2,
     4  7.83028959E+1,-2.16736253E+1, 2.98204280E+0,-2.04044209E-1,
     5  5.55676601E-3,               -1.46432100E+1, 6.83107919E+0,
     6 -1.24907508E+0, 1.41406855E-1,-9.94709007E-3, 3.16570356E-4/
      DATA C11 /
     2 -2.60507178E+3, 1.71419244E+3,-4.50632658E+2, 5.91751503E+1,
     3 -3.88164070E+0, 1.01752936E-1,               -3.68868193E-6,
     4  2.28941495E-6,-5.66767833E-7, 6.99552282E-8,-4.30495956E-9,
     5  1.0566816E-10,                8.07571327E+1,-4.59044171E+1,
     6  1.04582805E+1,-1.17649896E+0, 6.56479680E-2,-1.45759319E-3 /
      DATA C12 /
     2 -2.36123647E+3, 1.53666552E+3,-3.99573894E+2, 5.18934127E+1,
     3 -3.36616446E+0, 8.72505398E-2,               -4.34874146E+2,
     4  2.76201198E+2,-6.99216802E+1, 8.83345154E+0,-5.56915833E-1,
     5  1.40181117E-2,                6*0.0 /
      DATA C13 /
     2 -1.66857655E+3, 1.07393756E+3,-2.75925311E+2, 3.54060738E+1,
     3 -2.26875413E+0, 5.80737502E-2,               -8.68206246E+2,
     4  5.51082021E+2,-1.39651672E+2, 1.76615665E+1,-1.11474105E+0,
     5  2.80918810E-2,               -1.24175698E+2, 7.83456457E+1,
     6 -1.96158655E+1, 2.44987569E+0,-1.52626168E-1, 3.79453900E-3 /
      DATA C14 /
     2 -7.23428869E+2, 4.52601901E+2,-1.12918109E+2, 1.40785236E+1,
     3 -8.77132603E-1, 2.18523847E-2,               -3.67925366E+2,
     4  2.27801749E+2,-5.63139256E+1, 6.96970720E+0,-4.31392293E-1,
     5  1.06749184E-2,               -3.91665625E+2, 2.45914248E+2,
     6 -6.16164424E+1, 7.70134645E+0,-4.80173854E-1, 1.19478316E-2 /
      DATA C16 /
     2 -6.30703449E+1, 3.53098667E+1,-7.71409969E+0, 8.50300702E-1,
     3 -4.74936003E-2, 1.08607937E-3,                9.77516783E+2,
     4 -6.06713375E+2, 1.50090513E+2,-1.84627161E+1, 1.12856222E+0,
     5 -2.74016045E-2,                2.23914684E+2,-1.47570136E+2,
     6  3.81918598E+1,-4.84977487E+0, 3.03609041E-1,-7.51308575E-3/
      DATA C17 /
     2 -1.41743041E+2, 9.11490579E+1,-2.32901725E+1, 2.97839070E+0,
     3 -1.90121006E-1, 4.83977315E-3,                2.37940076E+2,
     4 -1.49281053E+2, 3.73551058E+1,-4.63170211E+0, 2.84929200E-1,
     5 -6.95817201E-3,                7.05206738E+2,-4.30210322E+2,
     6  1.04538026E+2,-1.26136527E+1, 7.55075317E-1,-1.79189988E-2 /
      DATA C20 /
     2 -5.21521085E+2, 4.10712446E+2,-1.26375869E+2, 1.90976557E+1,
     3 -1.42269952E+0, 4.19085267E-2,                1.65874025E+3,
     4 -1.04392185E+3, 2.61702809E+2,-3.26369424E+1, 2.02350114E+0,
     5 -4.98594460E-2,               -1.24819814E-3, 7.75158073E-4,
     6 -1.92014703E-4, 2.37150053E-5,-1.46034751E-6, 3.58695382E-8 /
      DATA C21 /
     2  1.81644604E+2,-7.20731826E+1, 5.86975892E+0, 1.07520225E+0,
     3 -2.00124526E-1, 8.87302770E-3,               -6.25304979E+2,
     4  3.90511641E+2,-9.66522233E+1, 1.18955806E+1,-7.28148753E-1,
     5  1.77552524E-2,               -4.01041660E+1, 2.44262397E+1,
     6 -5.78612200E+0, 7.00052494E-1,-4.30315116E-2, 1.07061834E-3 /
      DATA C22 /
     2 -5.42849573E+2, 3.46635141E+2,-8.90099156E+1, 1.15603978E+1,
     3 -7.60309452E-1, 2.02863075E-2,                7.41156498E+0,
     4 -1.62989642E+1, 6.88299761E+0,-1.14483565E+0, 8.56663842E-2,
     5 -2.39509300E-3,                1.90433458E+2,-1.27981973E+2,
     6  3.41092889E+1,-4.46260237E+0, 2.87468135E-1,-7.30136017E-3 /
      DATA C23 /
     2 -1.24333362E+3, 8.15378796E+2,-2.13919280E+2, 2.81081913E+1,
     3 -1.84869324E+0, 4.86918802E-2,                7.69236318E+2,
     4 -4.73580087E+2, 1.16641639E+2,-1.43096844E+1, 8.74037953E-1,
     5 -2.12299589E-2,                7.28260908E+2,-4.65567785E+2,
     6  1.18419589E+2,-1.49305828E+1, 9.33532870E-1,-2.31532069E-2 /
      DATA C24 /
     2 -8.80838409E+2, 5.72933536E+2,-1.49289839E+2, 1.95455757E+1,
     3 -1.28737652E+0, 3.41709398E-2,                3.32026608E+3,
     4 -2.07680692E+3, 5.17436644E+2,-6.41213593E+1, 3.94957079E+0,
     5 -9.66571288E-2,                8.99434106E+2,-5.56554851E+2,
     6  1.36799645E+2,-1.66493892E+1, 1.00343273E+0,-2.39467456E-2 /
      DATA C25 /
     2 -1.54913173E+3, 1.04762114E+3,-2.82777415E+2, 3.81262914E+1,
     3 -2.56771825E+0, 6.91046934E-2,                1.36807626E+3,
     4 -8.39953845E+2, 2.05165234E+2,-2.48590266E+1, 1.49207266E+0,
     5 -3.54240524E-2,                1.64215547E+2,-7.60372859E+1,
     6  1.21385978E+1,-5.98003176E-1,-2.36904392E-2, 2.20397061E-3 /
      DATA C26 /
     2 -1.15609527E+3, 7.46597652E+2,-1.92865672E+2, 2.49658410E+1,
     3 -1.61934455E+0, 4.21182087E-2,                2.71692895E+2,
     4 -1.52697440E+2, 3.36119665E+1,-3.56415427E+0, 1.80193259E-1,
     5 -3.38654879E-3,                5.42788652E+2,-3.26170152E+2,
     6  7.77054463E+1,-9.12244699E+0, 5.27184053E-1,-1.19689432E-2 /
      DATA C27 /
     2 -1.27572458E+3, 8.34945002E+2,-2.17863543E+2, 2.83665679E+1,
     3 -1.84229266E+0, 4.77591938E-2,               -4.17417685E+2,
     4  2.76839269E+2,-7.24430563E+1, 9.38616516E+0,-6.01647637E-1,
     5  1.52809452E-2,                1.94602744E+2,-1.15107876E+2,
     6  2.69761183E+1,-3.09225061E+0, 1.73365887E-1,-3.78711620E-3/
      DATA C28 /
     2 -1.02017263E+3, 6.68758438E+2,-1.74841425E+2, 2.28263930E+1,
     3 -1.48693754E+0, 3.86538338E-2,               -2.01279351E+2,
     4  1.01910058E+2,-1.92092108E+1, 1.62959379E+0,-5.55991468E-2,
     5  3.32146945E-4,                1.13021988E+2,-6.17971942E+1,
     6  1.33706056E+1,-1.40047265E+0, 7.08696964E-2,-1.37157842E-3/
      DATA C29 /
     2  8.31841948E+2,-5.28713346E+2, 1.33638828E+2,-1.67595185E+1,
     3  1.04137409E+0,-2.56014002E-2,                2.74142626E+3,
     4 -1.68010377E+3, 4.09637716E+2,-4.96430478E+1, 2.98843963E+0,
     5 -7.14361200E-2,               -1.51329149E+2, 1.01980858E+2,
     6 -2.68100884E+1, 3.47623044E+0,-2.22333466E-1, 5.61929630E-3/
      DATA C30 /
     2 -1.20140529E+3, 7.70434011E+2,-1.97293540E+2, 2.52193702E+1,
     3 -1.60917496E+0, 4.10029313E-2,               -3.81015122E+2,
     4  2.38979357E+2,-5.97019783E+1, 7.43924261E+0,-4.62365038E-1,
     5  1.14671249E-2,               -1.02446416E+2, 6.39284708E+1,
     6 -1.59154243E+1, 1.97595716E+0,-1.22341471E-1, 3.02204306E-3/
      DATA C38 /
     2  6.50892101E+2,-3.40217425E+2, 6.53893239E+1,-5.30225554E+0,
     3  1.23699526E-1, 2.86921883E-3,                1.14831179E+3,
     4 -7.13785765E+2, 1.76505337E+2,-2.16727738E+1, 1.32000916E+0,
     5 -3.18594119E-2,               -4.58857904E-3, 2.84991760E-3,
     6 -7.06034255E-4, 8.72098861E-5,-5.37095954E-6, 1.31940040E-7/
      DATA C39 /
     2  3.40651384E+3,-2.16510652E+3, 5.48071557E+2,-6.90145742E+1,
     3  4.32146653E+0,-1.07584489E-1,                2.40007747E+2,
     4 -1.65865174E+2, 4.42075274E+1,-5.72622786E+0, 3.63645809E-1,
     5 -9.08338755E-3,               -3.04672943E+1, 1.53131096E+1,
     6 -2.98576512E+0, 3.01521890E-1,-1.56834902E-2, 3.36484529E-4/
      DATA C40 /
C-K- 1998.11.9.!  It is found the data error !!!!!
     2 -5.86736112E+2, 3.73836394E+2,-9.52007830E+1, 1.21461902E+1,
     3 -7.76348813E-1,
     4  1.99265197E-2,                              -1.70866201E+2,
     5  1.23495311E+2,-3.46160939E+1, 4.75330281E+0,-3.19539990E-1,
     6  8.44862669E-3,
     7  4.15253105E+2,-2.60809264E+2,
     6  6.51595008E+1,-8.07244914E+0, 4.96869095E-1,-1.21570953E-2/
      DATA C46 /
     2 -5.05916266E+3, 3.06755122E+3,-7.41260220E+2, 8.92103693E+1,
     3 -5.34709856E+0, 1.27741440E-1,                1.63392630E+3,
     4 -9.29503960E+2, 2.10179266E+2,-2.35736936E+1, 1.31028981E+0,
     5 -2.88296397E-2,               -6.99185246E+1, 4.13687568E+1,
     6 -9.38368973E+0, 1.05370155E+0,-5.87366632E-2, 1.31666314E-3/
      DATA C56 /
     2  1.25802282E+3,-8.67056417E+2, 2.36061200E+2,-3.17162068E+1,
     3  2.10056494E+0,-5.47642624E-2,               -2.60418359E+3,
     4  1.62985198E+3,-4.05670422E+2, 5.02030146E+1,-3.08936584E+0,
     5  7.56650837E-2,               -1.59729467E-1, 9.92646093E-2,
     6 -2.46067151E-2, 3.04137466E-3,-1.87431750E-4, 4.60750505E-6/
      DATA C57 /
     2  1.38006252E+3,-8.88959516E+2, 2.27602564E+2,-2.89584138E+1,
     3  1.83220626E+0,-4.60907811E-2,                1.61733573E+3,
     4 -9.48380134E+2, 2.21895504E+2,-2.58709383E+1, 1.50359931E+0,
     5 -3.48334601E-2,               -2.08006100E+3, 1.21732617E+3,
     6 -2.83379267E+2, 3.28215398E+1,-1.89126734E+0, 4.33882551E-2/
      DATA C58 /
     2 -5.55282226E+3, 3.38703631E+3,-8.23882571E+2, 9.98914196E+1,
     3 -6.03404840E+0, 1.45276125E-1,               -7.81447000E+3,
     4  4.39852978E+3,-9.90459719E+2, 1.11523568E+2,-6.27588805E+0,
     5  1.41174743E-1,               -3.22176972E+3, 1.89138684E+3,
     6 -4.41914786E+2, 5.14089761E+1,-2.97776843E+0, 6.87226072E-2/
      DATA C59 /
     2 -4.37547209E+3, 2.64328344E+3,-6.36850288E+2, 7.64938454E+1,
     3 -4.57769848E+0, 1.09187930E-1,                1.05116056E+2,
     4 -6.57133659E+1, 1.58758366E+1,-1.85366921E+0, 1.06775487E-1,
     5 -2.43768992E-3,                4.98921791E+4,-2.87970911E+4,
     6  6.62402467E+3,-7.59317935E+2, 4.33911910E+1,-9.89126463E-1/
      DATA C60 /
     2 -3.69340716E+3, 2.07672551E+3,-4.61061880E+2, 5.04289636E+1,
     3 -2.70949776E+0, 5.70499143E-2,               -6.14001006E+3,
     4  3.43797948E+3,-7.68130434E+2, 8.55970362E+1,-4.75533573E+0,
     5  1.05363768E-1,               -8.98340934E+2, 4.95993575E+2,
     6 -1.09861091E+2, 1.21995868E+1,-6.77229656E-1, 1.50250139E-2/
      DATA C62 /
     2  9.48464532E+3,-5.90925804E+3, 1.46860826E+3,-1.81960304E+2,
     3  1.12387248E+1,-2.76756092E-1,               -6.59082469E+2,
     4  2.80193297E+2,-4.15250947E+1, 2.14083933E+0, 2.85426771E-2,
     5 -4.10269268E-3,                1.82123842E+3,-1.05190050E+3,
     6  2.42083558E+2,-2.77131764E+1, 1.57793614E+0,-3.57209194E-2/
      DATA C63 /
     2  1.12731107E+4,-6.99140090E+3, 1.73006013E+3,-2.13422170E+2,
     3  1.31204859E+1,-3.21441879E-1,                1.16784647E+3,
     4 -7.17324955E+2, 1.75410967E+2,-2.12994338E+1, 1.28332171E+0,
     5 -3.06458312E-2,               -2.02846263E+3, 1.24521575E+3,
     6 -3.04725159E+2, 3.72010364E+1,-2.26584074E+0, 5.50893177E-2/
      DATA C64 /
     2  2.22618205E+3,-1.39292299E+3, 3.47830305E+2,-4.32754448E+1,
     3  2.68193041E+0,-6.61790625E-2,               -2.87369723E+1,
     4 -1.94133158E+1, 1.26876586E+1,-2.37576504E+0, 1.88567734E-1,
     5 -5.49546486E-3,               -1.94763772E+3, 1.13737621E+3,
     6 -2.64005027E+2, 3.04959919E+1,-1.75313976E+0, 4.01393491E-2/
      data c65 /
     2  3.63934943e+3,-2.20476634e+3, 5.33344330e+2,-6.43316479e+1,
     3  3.86826858e+0,-9.26995173e-2,               -8.70647107e+2,
     4  5.32420130e+2,-1.29741869e+2, 1.58032737e+1,-9.62295469e-1,
     5  2.34648497e-2,                8.11558123e+2,-4.67434582e+2,
     6  1.07583056e+2,-1.23251149e+1, 7.02860514e-1,-1.59394115e-2/
      DATA C66 /
     2 -2.93290314E+2, 9.99790114E+1,-4.04447805E+0,-2.05098872E+0,
     3  2.82418737E-1,-1.06941883E-2,                2.64768769E+3,
     4 -1.59905729E+3, 3.85238971E+2,-4.62281078E+1, 2.76271089E+0,
     5 -6.57439176E-2,                1.30822682E+3,-7.46679156E+2,
     6  1.69716518E+2,-1.91592590E+1, 1.07376244E+0,-2.38653520E-2/
      data c68 /
     2 -6.72919146e+3, 3.95977305e+3,-9.27379717e+2, 1.08094682e+2,
     3 -6.27210975e+0, 1.45025407e-1,                8.77333770e+3,
     4 -5.28513990e+3, 1.26926452e+3,-1.51840542e+2, 9.04684500e+0,
     5 -2.14704214e-1,                2.65562213e+3,-1.49666461e+3,
     6  3.34740125e+2,-3.70678109e+1, 2.02963822e+0,-4.38640816e-2/
      DATA C69 /
     2  1.39943218E+4,-8.66622104E+3, 2.14147271E+3,-2.63838165E+2,
     3  1.62023118E+1,-3.96613548E-1,                5.25234498E+3,
     4 -3.28187713E+3, 8.15935429E+2,-1.00840805E+2, 6.19444705E+0,
     5 -1.51257435E-1,                1.98125519E+4,-1.15375165E+4,
     6  2.67546870E+3,-3.08902709E+2, 1.77611962E+1,-4.06891034E-1/
      DATA C70 /
     2  1.01225468E+4,-6.11281699E+3, 1.47263702E+3,-1.76872944E+2,
     3  1.05881310E+1,-2.52649288E-1,                2.02501196E+4,
     4 -1.20810049E+4, 2.87249350E+3,-3.40216305E+2, 2.00694419E+1,
     5 -4.71639888E-1,                2.20972517E+4,-1.29759231E+4,
     6  3.03586521E+3,-3.53736304E+2, 2.05261891E+1,-4.74477383E-1/
      data c71 /
     2  3.54955843e+3,-2.10593597e+3, 4.97966667e+2,-5.86264416e+1,
     3  3.43547361e+0,-8.01086936e-2,               -9.71078821e+2,
     4  6.25579205e+2,-1.58214825e+2, 1.96827109e+1,-1.20787084e+0,
     5  2.93611437e-2,               -4.32820064e+3, 2.63014122e+3,
     6 -6.37639995e+2, 7.70883404e+1,-4.64747171e+0, 1.11804759e-1/
      DATA C80 /
     2 -1.20415788E+4, 7.27607734E+3,-1.75552471E+3, 2.11423831E+2,
     3 -1.27106500E+1, 3.05187054E-1,               -1.10841513E+3,
     4  6.83010331E+2,-1.67898502E+2, 2.05962831E+1,-1.26096395E+0,
     5  3.08269134E-2,               -2.51144794E+3, 1.46151135E+3,
     6 -3.38801957E+2, 3.91264052E+1,-2.25228940E+0, 5.17353781E-2/
C ----------- PARITION FUNCTION -------------------
      XT=DLOG(TEMP)
       DO 2020 IA=1,6
          A(IA)=PPFC(IA,ION,iatom)
 2020  CONTINUE
      PART=DEXP(A(1)+(A(2)+(A(3)+(A(4)+(A(5)+A(6)*XT)*XT)*XT)*XT)*XT)
*********  12.00 = neutral  ion=0   1st ionized ion=1  ********
      RETURN
      END




      DOUBLE PRECISION FUNCTION VOIGT(A,V)
C---- INTERPOLATES FROM HARRIS AP.J. 1948
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION H0(41),H1(81),H2(41)
      save
      DATA H0 /
     11.0000000, .9900500, .9607890, .9139310, .8521440, .7788010,
     2 .6976760, .6126260, .5272920, .4448580, .3678790, .2981970,
     3 .2369280, .1845200, .1408580, .1053990, .0773050, .0555760,
     4 .0391640, .0270520, .0183156, .0121552, .0079071, .0050418,
     5 .0031511, .0019305, .0011592, .0006823, .0003937, .0002226,
     6 .0001234, .0000671, .0000357, .0000186, .0000095, .0000048,
     7 .0000024, .0000011, .0000005, .0000002, .0000001 /
      DATA H1 /
     1-1.1283800,-1.1059600,-1.0404800,-.9370300,-.8034600,-.6494500,
     2-.4855200,-.3219200,-.1677200,-.0301200, 0.859400, .1778900,
     3 .2453700, .2898100, .3139400, .3213000, .3157300, .3009400,
     4 .2802700, .2564800, .2317260, .2075280, .1848820, .1643410,
     5 .1461280, .1302360, .1165150, .1047390, .0946530, .0860050,
     6 .0785650, .0721290, .0665260, .0616150, .0572810, .0534300,
     7 .0499880, .0468940, .0440980, .0415610, .0392500, .0351950,
     8 .0317620, .0288240, .0262880, .0240810, .0221460, .0204410,
     9 .0189290, .0175820, .0163750, .0152910, .0143120, .0134260,
     1 .0126200, .0118860, .0112145, .0105990, .0100332, .0095119,
     2 .0090306, .0085852, .0081722, .0077885, .0074314, .0070985,
     3 .0067875, .0064967, .0062243, .0059688, .0057287, .0055030,
     4 .0052903, .0050898, .0049006, .0047217, .0045526, .0043924,
     5 .0042405, .0040964, .0039595 /
      DATA H2 /
     11.0000000, .9702000, .8839000, .7494000, .5795000, .3894000,
     2 .1953000, .0123000,-.1476000,-.2758000,-.3679000,-.4234000,
     3-.4454000,-.4392000,-.4113000,-.3689000,-.3185000,-.2657000,
     4-.2146000,-.1683000,-.1282100,-.0950500,-.0686300,-.0483000,
     5-.0331500,-.0222000,-.0145100,-.0092700,-.0057800,-.0035200,
     6-.0021000,-.0012200,-.0007000,-.0003900,-.0002100,-.0001100,
     7-.0000600,-.0000300,-.0000100,-.0000100, .0000000 /
      V0=V*10.0
      N=V0
      IF(N.LT.40) GO TO 1
      IF(N.LT.120) GO TO 2
      VOIGT=(0.56419+0.846/(V**2))/(V**2)*A
      RETURN
    1 V1=N
      N=N+1
      V2=V0-V1
      N1=N+1
      VOIGT=V2*(H0(N1)-H0(N)+A*(H1(N1)-H1(N)+A*(H2(N1)-H2(N))))+
     *  H0(N)+A*(H1(N)+A*H2(N))
      RETURN
    2 N=N/2+20
      V1=(N-20)*2
      N=N+1
      V2=(V0-V1)/2.0
      N1=N+1
      VOIGT=A*((H1(N1)-H1(N))*V2+H1(N))
      RETURN
      END





      DOUBLE PRECISION FUNCTION ABHYD(T,FREQ)
C.... HYDROGEN OPACITY PER NEUTRAL ATOM. SCALE 1.
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION G(10)
      save
      U1=157786.46/T
      U10=U1/100.
      EHKT=DEXP(-4.799275E-11/T*FREQ)
      IF(FREQ-FR) 1,2,1
    2 I=2
      GO TO 3
    1 FR=FREQ
      I=1
      M0=IDINT(DSQRT(3.2880515E15/FR))+1
      W=2.9979E14/FREQ
      IF(W-0.545) 400,500,500
  400 J=1
      GOTO 3
  500 J=2
    3 BF=0.0
      DO 200 M=M0,9
      XM=M
      XM2=XM*XM
      GO TO (10,20),I
   10 G(M)=GAUNT(FREQ,XM)
   20 BF=BF+G(M)*DEXP(U1/XM2)/XM/XM2
  200 CONTINUE
      GO TO (40,50),J
C
C---- BF ---  B-F OPACITY SUMMATION TERM.
C
   40 G2=1.0
      GO TO 300
   50 AA=1.084+3.729863E-6*T
      BB=0.00161+5.279343E-6*T
      CC=0.0192+(-7.715657E-6+(1.115107E-9+(-6.113020E-14+1.13162E-18
     *         *T)*T)*T)*T
      G2=AA+(BB-CC*W)*W
  300 FF=(DEXP(U10)-1.0+G2)/2./U1
      ABHYD=(BF+FF)*2.0898E-14*DEXP(-U1)*(1.0-EHKT)*W*W*W/2.0
      RETURN
      END



      DOUBLE PRECISION FUNCTION GAUNT(WAVE,X)
C.....  HYDROGEN B-F GAUNT FACTORS
      IMPLICIT REAL*8 (A-H,O-Z)
      K=X
      W=2.9979E14/WAVE
      IF(K-6) 90,6,7
   90 GO TO (1,2,3,4,5),K
    1 GAUNT=0.9916+(0.09068-25.24*W)*W
      RETURN
    2 GAUNT=1.105+(-0.7922+0.4536*W)*W
      RETURN
    3 GAUNT=1.101+(-0.3290+0.1152*W)*W
      RETURN
    4 GAUNT=1.101+(-0.1923+0.0511*W)*W
      RETURN
    5 GAUNT=1.102+(-0.1304+0.02638*W)*W
      RETURN
    6 GAUNT=1.0986+(-0.0902+0.01367*W)*W
      RETURN
    7 GAUNT=1.0
      RETURN
      END




      DOUBLE PRECISION FUNCTION ABNEGH(TEMP,FREQ)
      IMPLICIT REAL*8 (A-H,O-Z)
      TH=5040./TEMP
      IF(FREQ-FR) 30,600,30
   30 FR=FREQ
      CHK=9.5224E-15*FR
      W=2.9979E15/FR
      W16=16.419-W
      IF(W16) 500,210,210
  500 I=2
      GO TO 600
  210 I=1
      IF(W-14.2) 100,100,200
  100 STAR=0.00680133+(0.178708+(0.16479+(-0.0204842+5.95244E-4*W)*W)
     *      *W)*W
      GO TO 600
  200 STAR=(0.269818+(0.220190+(-0.0411288+0.00273236*W16)*W16)*W16)*W16
  600 A=0.0053666+(-0.011493+0.027039*TH)*TH
      B=-3.2062+(11.924-5.939*TH)*TH
      C=-0.40192+(7.0355-0.34592*TH)*TH
      ABNEGH =A+(B+C*W)*W/1000.
      GO TO (300,2),I
  300 BF=0.4158*TH*TH*DSQRT(TH)*DEXP(1.737*TH)*(1.-DEXP(-TH*CHK))*STAR
      ABNEGH=BF+ABNEGH
    2 RETURN
      END




      DOUBLE PRECISION FUNCTION AVCAR(TH,FR)
      IMPLICIT REAL*8 (A-H,O-Z)
      IF(FR.LT.2.9979E18/1444.) GO TO 13
      HV=0.43429/TH
      IF(FR.GE.2.9979E18/1100.) GO TO 11
      IF(FR.GE.2.9979E18/1239.) GO TO  7
      AVCAR=0.898E8/DEXP(2.56/HV)
      RETURN
    7 AVCAR=4.86E8/DEXP(1.18/HV)
      RETURN
   11 AVCAR=0.776E9+0.75E24/FR
      RETURN
   13 AVCAR=0.
      RETURN
      END




      DOUBLE PRECISION FUNCTION AVMET(THETA,FREQ,ASI,AMG)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FLIM(11)
      DATA FLIM/ 19.63E14, 18.47E14, 17.81E14, 15.08E14, 14.43E14,
     * 11.9E14,   7.99E14,  7.73E14,  6.00E14,  4.29E14,  3.50E14 /
      TK=0.43429/THETA
      IF(FREQ-FR) 30,50,30
   30 FR=FREQ
      HV=4.1352E-15*FR
      A=0.
      B=0.
      C=0.
      E=0.
      G=0.
      V=0.
      W=0.
      X=0.
      Z=0.
      WFR=(11.91E14/FR)**11
      CFR=DSQRT((FR/15.08E14)**3)
      DO 40 I=1,10
      IF(FLIM(I)-FR) 50,50,40
   40 CONTINUE
      I=11
      GO TO 11
   50 I=I
      GO TO (1,2,3,4,44,5,6,7,8,10,11),I
    1 IF(FR-22.20E14) 101,101,102
  101 A=(FR/19.63E14)**3
      GO TO 2
  102 A=(22.20E14/FR)**2*1.446
    2 V=0.0282
      I=3
    3 B=0.444/DEXP(0.78/TK)
    4 C=CFR*0.0628/DEXP(1.91/TK)
   44 G=0.230
    5 W=WFR*2.32/DEXP(2.71/TK)
    6 X=0.065/DEXP(4.33/TK)
    7 D=0.974*TK/DEXP(5.0/TK)
    8 Y=1.90*TK/DEXP(5.24/TK)
      E=0.069/DEXP(5.7/TK)
   10 Z=0.090/DEXP(5.9/TK)
      GO TO (13,13,13,13,13,13,13,13,12,11,11),I
   11 Y=0.962*TK/DEXP((7.64-HV)/TK)
   12 D=0.493*TK/DEXP((8.14-HV)/TK)
   13 SUM=ASI*(A+B+C+D+E)*0.825+AMG*(V+W+X+Y+Z)*0.725
      AVMET=(1.E26/FR)*SUM*(1.-DEXP(-HV/TK))*(2.815E29/FR/FR)
  100 RETURN
      END



      DOUBLE PRECISION FUNCTION H2PLOP(TM,FREQ)
C....  H2+    ATLAS 5  P.58
      IMPLICIT REAL*8 (A-H,O-Z)
      IF(FREQ.EQ.FROLD) GO TO 10
      FROLD=FREQ
      FR=FREQ*1.0E-15
      FLN=DLOG(FREQ)
      ES=-7.342E-3+(-2.409+(1.028+(-0.423+(0.1224-0.01351*FR)*FR)*FR)
     *     *FR)*FR
      H=-3023.3+(377.97+(-18.2496+(0.39207-3.1672E-3*FLN)*FLN)*FLN)*FLN
   10 H2PLOP=DEXP(-ES/(8.61734E-5*TM)+H)*(1.0-DEXP(-4.7992746E4*FR/TM))
      RETURN
      END




      SUBROUTINE INTEG(X,F,FINT,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N),F(N),FINT(N)
      DIMENSION A(71),B(71),C(71)
      CALL PARCOE(F,X,A,B,C,N)
      FINT(1)=(A(1)+(B(1)/2.+C(1)/3.*X(1))*X(1))*X(1)
      FINT(2)=(A(1)+(B(1)/2.+C(1)/3.*X(2))*X(2))*X(2)
      IF(N.EQ.2) RETURN
      N1=N-1
      DO 10 I=2,N1
   10 FINT(I+1)=FINT(I)+(A(I)+B(I)/2.*(X(I+1)+X(I))+
     * C(I)/3.*((X(I+1)+X(I))*X(I+1)+X(I)*X(I)))*(X(I+1)-X(I))
      RETURN
      END




      SUBROUTINE PARCOE(F,X,A,B,C,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION F(N),A(N),B(N),C(N),X(N)
      C(1)=0.0
      B(1)=(F(2)-F(1))/(X(2)-X(1))
      A(1)=F(1)-X(1)*B(1)
      N1=N-1
      C(N)=0.0
      B(N)=(F(N)-F(N1))/(X(N)-X(N1))
      A(N)=F(N)-X(N)*B(N)
      IF(N.EQ.2) RETURN
      DO 1 J=2,N1
      J1=J-1
      D=(F(J)-F(J1))/(X(J)-X(J1))
      C(J)=F(J+1)/((X(J+1)-X(J))*(X(J+1)-X(J1)))-F(J)/((X(J)-X(J1))*
     *(X(J+1)-X(J)))+F(J1)/((X(J)-X(J1))*(X(J+1)-X(J1)))
      B(J)=D-(X(J)+X(J1))*C(J)
    1 A(J)=F(J1)-X(J1)*D+X(J)*X(J1)*C(J)
      N1=N1-1
      DO 2 J=2,N1
      IF(C(J).EQ.0.0) GO TO 2
      J1=J+1
      WT=DABS(C(J1))/(DABS(C(J1))+DABS(C(J)))
      A(J)=A(J1)+WT*(A(J)-A(J1))
      B(J)=B(J1)+WT*(B(J)-B(J1))
      C(J)=C(J1)+WT*(C(J)-C(J1))
    2 CONTINUE
      RETURN
      END



      SUBROUTINE HOKAN(NTB,TBX,TBF,N,X,F)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TBX(NTB),TBF(NTB)
      IF(N.GT.NTB) GO TO 2
      L=0
      M=0
      D=X-TBX(1)
      IF(D.LT.0.0) L=1
      DO 1 I=1,NTB
      J=I
      D=X-TBX(I)
      IF(D.EQ.0.0) GO TO 3
      IF(D.LT.0.0) M=1
      IF(L.NE.M) GO TO 4
      M=0
    1 CONTINUE
      F=1.0E-38
      WRITE(*,91) F
   91 FORMAT(' *ERROR* RANGE OUT OF X, F=',1PE12.1)
      RETURN
    2 F=1.0E+38
      WRITE(*,92) F
   92 FORMAT(' *ERROR* N .GT. NTB, F=',1PE12.1)
      RETURN
    3 F=TBF(J)
      RETURN
    4 KI=J-N/2
      IF(KI.LT.1) KI=1
      KF=KI+N-1
      IF(KF.GT.NTB) KI=NTB-N+1
      KF=KI+N-1
C      INTERPOLATION
      S=0.0
      PAI=1.0
      DO 5 I=KI,KF
      D=1.0
      DO 6 J=KI,KF
      DD=TBX(I)-TBX(J)
      IF(I.EQ.J) DD=X-TBX(I)
      D=D*DD
    6 CONTINUE
      PAI=PAI*(X-TBX(I))
      S=S+TBF(I)/D
    5 CONTINUE
      F=PAI*S
      RETURN
      END





